package hikapro.com.backpack.model;

import android.os.Message;

import hikapro.com.backpack.model.entities.Item;
import hikapro.com.backpack.presenter.Presenter;

/**
 * Created by tariel on 23/04/16.
 */
public class DetailModel implements Model.Detail {

    private Presenter.ItemDetail    presenter;
    private Item                    item;

    public DetailModel() {

    }

    // detail -->

    @Override
    public int getCount() {
        return 1;
    }
    @Override
    public Item findItem(int id) {
        return item;
    }

    // detail <--

    // events -->

    @Override
    public void notifyDataSetChanged() {
        presenter.notifyDataSetChanged();
    }
    @Override
    public void onDestroy(boolean isConfigurationChanging) {
        if ( !isConfigurationChanging ) {
            presenter = null;
        }
    }

    private void sendMessage(String message) {
        presenter.showMessage(message);
    }

    // events <--

    // process -->
    @Override
    public void executeQuery() {
        notifyDataSetChanged();
    }
    // process <--


    @Override
    public void setPresenter(Presenter.ItemDetail presenter) {
        this.presenter  = presenter;
        this.item       = presenter.getCurrentItem();

    }

    @Override
    public Presenter.ItemDetail getPresenter() {
        return presenter;
    }

    @Override
    public void onEvent(Message event) {

    }
}
